diff --git a/cmd/Kconfig b/cmd/Kconfig
index cd72ea8e56a9..5e2885bbaa95 100644
--- a/cmd/Kconfig
+++ b/cmd/Kconfig
@@ -591,10 +591,17 @@ config CMD_GPT
 	bool "GPT (GUID Partition Table) command"
 	select PARTITION_UUIDS
 	select EFI_PARTITION
+	imply RANDOM_UUID
 	help
 	  Enable the 'gpt' command to ready and write GPT style partition
 	  tables.
 
+config RANDOM_UUID
+	bool "GPT Random UUID generation"
+	help
+	  Enable the generation of partitions with random UUIDs if none
+	  are provided.
+
 config CMD_GPT_RENAME
 	bool "GPT partition renaming commands"
 	depends on CMD_GPT
diff --git a/configs/evb-rv1108_defconfig b/configs/evb-rv1108_defconfig
index 3deea7c0dcb1..a43683041359 100644
--- a/configs/evb-rv1108_defconfig
+++ b/configs/evb-rv1108_defconfig
@@ -7,6 +7,7 @@ CONFIG_DEBUG_UART=y
 CONFIG_ENV_IS_NOWHERE=y
 # CONFIG_DISPLAY_CPUINFO is not set
 # CONFIG_CMD_IMLS is not set
+CONFIG_RANDOM_UUID=y
 CONFIG_CMD_SF=y
 # CONFIG_CMD_SETEXPR is not set
 CONFIG_CMD_CACHE=y
diff --git a/configs/rock_defconfig b/configs/rock_defconfig
index 2ad6a6c521da..b03856889981 100644
--- a/configs/rock_defconfig
+++ b/configs/rock_defconfig
@@ -14,6 +14,7 @@ CONFIG_ENV_IS_IN_MMC=y
 CONFIG_SPL_STACK_R=y
 CONFIG_SPL_STACK_R_MALLOC_SIMPLE_LEN=0x2000
 # CONFIG_CMD_IMLS is not set
+CONFIG_RANDOM_UUID=y
 CONFIG_CMD_MMC=y
 CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
diff --git a/include/configs/am57xx_evm.h b/include/configs/am57xx_evm.h
index 9f07bba0c898..4de59a644fb6 100644
--- a/include/configs/am57xx_evm.h
+++ b/include/configs/am57xx_evm.h
@@ -72,7 +72,6 @@
 #include <configs/ti_omap5_common.h>
 
 /* Enhance our eMMC support / experience. */
-#define CONFIG_RANDOM_UUID
 #define CONFIG_HSMMC2_8BIT
 
 /* CPSW Ethernet */
diff --git a/include/configs/dra7xx_evm.h b/include/configs/dra7xx_evm.h
index 1a58c6ef24f2..0d847808e021 100644
--- a/include/configs/dra7xx_evm.h
+++ b/include/configs/dra7xx_evm.h
@@ -100,7 +100,6 @@
 #include <configs/ti_omap5_common.h>
 
 /* Enhance our eMMC support / experience. */
-#define CONFIG_RANDOM_UUID
 #define CONFIG_HSMMC2_8BIT
 
 /* CPSW Ethernet */
diff --git a/include/configs/edison.h b/include/configs/edison.h
index 03aa70230619..bec79496441c 100644
--- a/include/configs/edison.h
+++ b/include/configs/edison.h
@@ -14,7 +14,6 @@
 #define CONFIG_BOOTCOMMAND "run bootcmd"
 
 /* DISK Partition support */
-#define CONFIG_RANDOM_UUID
 
 /* Miscellaneous configurable options */
 #define CONFIG_SYS_LONGHELP
diff --git a/include/configs/odroid.h b/include/configs/odroid.h
index 563854d9bbbf..22686657b62a 100644
--- a/include/configs/odroid.h
+++ b/include/configs/odroid.h
@@ -175,7 +175,6 @@
 	"fdtaddr=40800000\0"
 
 /* GPT */
-#define CONFIG_RANDOM_UUID
 
 /* Security subsystem - enable hw_rand() */
 #define CONFIG_EXYNOS_ACE_SHA
diff --git a/include/configs/rockchip-common.h b/include/configs/rockchip-common.h
index 29a492dc5529..bd3364a81bd9 100644
--- a/include/configs/rockchip-common.h
+++ b/include/configs/rockchip-common.h
@@ -27,8 +27,6 @@
 	func(DHCP, dchp, na)
 #endif
 
-#define CONFIG_RANDOM_UUID
-
 #ifdef CONFIG_ARM64
 #define ROOT_UUID "B921B045-1DF0-41C3-AF44-4C6F280D3FAE;\0"
 #else
diff --git a/include/configs/trats.h b/include/configs/trats.h
index 3059d89ac90f..08cd7cf266a8 100644
--- a/include/configs/trats.h
+++ b/include/configs/trats.h
@@ -170,7 +170,6 @@
 #define CONFIG_SYS_SPL_ARGS_ADDR        CONFIG_SYS_SDRAM_BASE + 0x100
 
 /* GPT */
-#define CONFIG_RANDOM_UUID
 
 /* Security subsystem - enable hw_rand() */
 #define CONFIG_EXYNOS_ACE_SHA
diff --git a/include/configs/trats2.h b/include/configs/trats2.h
index 1f3ce9d94104..b523b6d1b8ae 100644
--- a/include/configs/trats2.h
+++ b/include/configs/trats2.h
@@ -151,7 +151,6 @@
 	"fdtaddr=40800000\0" \
 
 /* GPT */
-#define CONFIG_RANDOM_UUID
 
 /* Security subsystem - enable hw_rand() */
 #define CONFIG_EXYNOS_ACE_SHA
diff --git a/include/configs/vinco.h b/include/configs/vinco.h
index adff1b6d7f71..a0c522c86781 100644
--- a/include/configs/vinco.h
+++ b/include/configs/vinco.h
@@ -59,7 +59,6 @@
 #define CONFIG_SYS_MMC_CLK_OD		500000
 
 /* For generating MMC partitions */
-#define CONFIG_RANDOM_UUID
 
 #endif
 
diff --git a/include/configs/xilinx_zynqmp.h b/include/configs/xilinx_zynqmp.h
index 77d7899deff4..3b1119f94e51 100644
--- a/include/configs/xilinx_zynqmp.h
+++ b/include/configs/xilinx_zynqmp.h
@@ -114,7 +114,6 @@
 #  define CONFIG_FASTBOOT_FLASH_MMC_DEV 0
 # endif
 
-# define CONFIG_RANDOM_UUID
 # define PARTS_DEFAULT \
 	"partitions=uuid_disk=${uuid_gpt_disk};" \
 	"name=""boot"",size=16M,uuid=${uuid_gpt_boot};" \
diff --git a/scripts/config_whitelist.txt b/scripts/config_whitelist.txt
index 4689d6310f0c..50ac011a6bdd 100644
--- a/scripts/config_whitelist.txt
+++ b/scripts/config_whitelist.txt
@@ -1903,7 +1903,6 @@ CONFIG_RAMDISK_ADDR
 CONFIG_RAMDISK_BOOT
 CONFIG_RAM_BOOT
 CONFIG_RAM_BOOT_PHYS
-CONFIG_RANDOM_UUID
 CONFIG_RCAR_BOARD_STRING
 CONFIG_RD_LVL
 CONFIG_REALMODE_DEBUG